package main

import (
	"math/rand"

	jsoniter "github.com/json-iterator/go"
	"github.com/mhaya/game/game_cluster/internal/mdb/eventmodels"
)

var (
	json = jsoniter.ConfigCompatibleWithStandardLibrary
)

func getRewardFakeData(users []*eventmodels.UserBasic) []*eventmodels.UserRewardEventContent {
	datas := make([]*eventmodels.UserRewardEventContent, 0, 8)

	for i := 0; i < count; i++ {
		source := rand.Intn(12) + 1

		addRewards := make([]eventmodels.ItemReward, 0, 8)
		addRewards = append(addRewards, eventmodels.ItemReward{
			ItemBaseType: rand.Intn(5) + 1,
			ItemID:       rand.Intn(7) + 1,
			Amount:       rand.Intn(100) + 1,
		})

		addRewardBytes, err := json.Marshal(addRewards)
		if err != nil {
			panic(err)
		}

		subRewards := make([]eventmodels.ItemReward, 0, 8)
		subRewards = append(subRewards, eventmodels.ItemReward{
			ItemBaseType: rand.Intn(5) + 1,
			ItemID:       rand.Intn(7) + 1,
			Amount:       rand.Intn(100) + 1,
		})

		subRewardBytes, err := json.Marshal(subRewards)
		if err != nil {
			panic(err)
		}

		desc := ""
		switch source {
		case 11: // SourceDraw
			descDraw := eventmodels.DescDraw{
				ID:     rand.Intn(12) + 1,
				CurID:  rand.Intn(12) + 1,
				Reward: addRewards,
			}

			bytes, err := json.Marshal(descDraw)
			if err != nil {
				panic(err)
			}

			desc = string(bytes)

		default:
			desc = ""
		}

		userBasic := getUserBasic(users)
		eventBasic := getEventBasic()

		datas = append(datas, &eventmodels.UserRewardEventContent{
			UserBasic:  *userBasic,
			EventBasic: *eventBasic,
			Source:     source,
			SourceId:   rand.Intn(2) + 1,
			AddReward:  string(addRewardBytes),
			SubReward:  string(subRewardBytes),
			Desc:       desc,
		})
	}

	return datas
}
